#include "arraySum.h"

__global__ void somma(double *host_v1, double *host_v2, double *host_ris) 
{ 
	int tid = blockIdx.x;
	host_ris[tid] = host_v1[tid] + host_v2[tid];
}
	
void arraySum(double *host_v1, double *host_v2, double *host_ris, int N)	
{	
	double *device_v1 = NULL;
	double *device_v2 = NULL;
	double *device_ris = NULL;
	
	// Inizializzo il vettore di output a tutti zeri
	memset(host_ris, 0, N*sizeof(double));
	
	// Alloco sulla GPU
	cudaMalloc((void**) &device_v1, N*sizeof(double));
	cudaMalloc((void**) &device_v2, N*sizeof(double));
	cudaMalloc((void**) &device_ris, N*sizeof(double));
	
	// Metto host_v1 e host_v2 sulla GPU
	cudaMemcpy(device_v1, host_v1, N*sizeof(double), cudaMemcpyHostToDevice);
	cudaMemcpy(device_v2, host_v2, N*sizeof(double), cudaMemcpyHostToDevice);
	
	// Invoco il kernel
	// Ogni thread si occuperà dell'operazione device_v1(i) + device_v2(i)
	somma<<<N,1>>>(device_v1,device_v2,device_ris);
	
	// Metto il risultato della somma su CPU
	cudaMemcpy(host_ris,device_ris,N*sizeof(double), cudaMemcpyDeviceToHost);
	
	// Libero la memoria
	cudaFree(device_v1);
	cudaFree(device_v2);
	cudaFree(device_ris);
}

	